package cn.iocoder.yudao.module.bpm.service.oa;

import cn.iocoder.yudao.module.bpm.api.task.BpmProcessInstanceApi;
import cn.iocoder.yudao.module.bpm.api.task.dto.BpmProcessInstanceCreateReqDTO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.overtime.BpmOAOvertimeCreateReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.upload.UploadUserFile;
import cn.iocoder.yudao.module.bpm.convert.oa.BpmOAOvertimeConvert;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAOvertimeDO;
import cn.iocoder.yudao.module.bpm.dal.mysql.oa.BpmOAOvertimeMapper;
import cn.iocoder.yudao.module.bpm.enums.task.BpmProcessInstanceResultEnum;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.bpm.enums.ErrorCodeConstants.OA_OVERTIME_NOT_EXISTS;

/**
 * OA 加班申请 Service 实现类
 *
 * @author 符溶馨

 */
@Service
@Validated
public class BpmOAOvertimeServiceImpl extends BpmOABaseService implements BpmOAOvertimeService{

    /**
     * OA 加班对应的流程定义 KEY
     */
    public static final String PROCESS_KEY = "oa_overtime";

    @Resource
    private BpmOAOvertimeMapper overtimeMapper;

    @Resource
    private BpmProcessInstanceApi processInstanceApi;
    
    @Override
    public Long createOvertime(Long userId, BpmOAOvertimeCreateReqVO createReqVO) {

        //插入OA 转正申请
        BpmOAOvertimeDO overtime = BpmOAOvertimeConvert.INSTANCE.convert(createReqVO).setUserId(userId)
                .setResult(BpmProcessInstanceResultEnum.PROCESS.getResult());
        overtimeMapper.insert(overtime) ;

        // 发起 BPM 流程
        Map<String, Object> processInstanceVariables = new HashMap<>();
        String processInstanceId = processInstanceApi.createProcessInstance(userId,
                new BpmProcessInstanceCreateReqDTO().setProcessDefinitionKey(PROCESS_KEY)
                        .setVariables(processInstanceVariables).setBusinessKey(String.valueOf(overtime.getId()))).getCheckedData();

        // 将工作流的编号，更新到 OA 加班单中
        overtimeMapper.updateById(new BpmOAOvertimeDO().setId(overtime.getId()).setProcessInstanceId(processInstanceId));

        List<UploadUserFile> fileItems = createReqVO.getFileItems() ;
        //这里的逻辑，如果fileItems不为空，且有数据，那么说明是上传了附件的，则需要更工作流文件表对应的实例Id
        if (fileItems != null && !fileItems.isEmpty()) {
            uploadBpmFileProcessInstanceId(processInstanceId,fileItems) ;
        }
        return overtime.getId();
    }

    @Override
    public void updateOvertimeResult(Long id, Integer result) {

        validateLeaveExists(id);
        overtimeMapper.updateById(new BpmOAOvertimeDO().setId(id).setResult(result));
    }

    private void validateLeaveExists(Long id) {
        if (overtimeMapper.selectById(id) == null) {
            throw exception(OA_OVERTIME_NOT_EXISTS);
        }
    }
    
    @Override
    public BpmOAOvertimeDO getOvertime(Long id) {

        return overtimeMapper.selectById(id);
    }
}
